function varargout = digits_recognition(varargin)
% DIGITS_RECOGNITION M-file for digits_recognition.fig
%      DIGITS_RECOGNITION, by itself, creates a new DIGITS_RECOGNITION or raises the existing
%      singleton*.
%
%      H = DIGITS_RECOGNITION returns the handle to a new DIGITS_RECOGNITION or the handle to
%      the existing singleton*.
%
%      DIGITS_RECOGNITION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIGITS_RECOGNITION.M with the given input arguments.
%
%      DIGITS_RECOGNITION('Property','Value',...) creates a new DIGITS_RECOGNITION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before digits_recognition_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to digits_recognition_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help digits_recognition

% Last Modified by GUIDE v2.5 20-Nov-2012 15:45:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @digits_recognition_OpeningFcn, ...
                   'gui_OutputFcn',  @digits_recognition_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before digits_recognition is made visible.
function digits_recognition_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to digits_recognition (see VARARGIN)

% Choose default command line output for digits_recognition
handles.output = hObject;

% Set analog input to empty values
handles.AI = [];

% Initialize axis for autocorrelation function
axes(handles.a_test);
handles.a_test_line = plot(0,0,'');
grid on;
xlabel('{\itnT} [s] \rightarrow');
ylabel('{\its}[{\itnT}] \rightarrow');
title('Zaznamenany signal');

set(hObject,'RendererMode','Manual')  %  If you don't do this, the surface plot
set(hObject,'Renderer','OpenGL')      %    will draw VERY slowly.

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes digits_recognition wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = digits_recognition_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function e_len_Callback(hObject, eventdata, handles)
% hObject    handle to e_len (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of e_len as text
%        str2double(get(hObject,'String')) returns contents of e_len as a double


% --- Executes during object creation, after setting all properties.
function e_len_CreateFcn(hObject, eventdata, handles)
% hObject    handle to e_len (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function e_fs_Callback(hObject, eventdata, handles)
% hObject    handle to e_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of e_fs as text
%        str2double(get(hObject,'String')) returns contents of e_fs as a double


% --- Executes during object creation, after setting all properties.
function e_fs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to e_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in b_start.
function b_start_Callback(hObject, eventdata, handles)
% hObject    handle to b_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if(strcmp(get(handles.b_start, 'String'), 'Start'))
    set(handles.b_start, 'String', 'Stop');
    dis_en_start(handles); % Enable or dsable functionalities
    
    handles = init_ai(hObject, handles); % Initialize analog input
    start(handles.AI);
    trigger(handles.AI);
else
    set(handles.b_start, 'String', 'Start');
    dis_en_stop(handles); % Enable or dsable functionalities
    
    if(~isempty(handles.AI))
        % Get the data
        x = peekdata(handles.AI,handles.AI.SamplesAvailable);

        % Display the loaded signal
        disp_test_sig(x, handles);

        % Classify the number
        fs = str2double(get(handles.e_fs, 'String'));
        num = classify(x, fs);
        set(handles.t_number,'String',num2str(num));
        
        stop(handles.AI);
        delete(handles.AI);
    end
end


% --- Executes on button press in b_stop.
function b_stop_Callback(hObject, eventdata, handles)
% hObject    handle to b_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function dis_en_start(handles)

set(handles.e_len, 'Enable', 'off');
set(handles.e_fs, 'Enable', 'off');

function dis_en_stop(handles)

set(handles.e_len, 'Enable', 'on');
set(handles.e_fs, 'Enable', 'on');

function handles = init_ai(hObject, handles)

% Empty the figures
set(handles.a_test_line, 'XData', 0, 'YData', 0);

% Create a device object
AI = analoginput('winsound');

handles.AI = AI;
guidata(hObject, handles);

% Add channels
chan = addchannel(AI,1);

% Configure property values
duration = str2double(get(handles.e_len, 'String'))/1000;
fs = str2double(get(handles.e_fs, 'String'));

data.handles = handles;

% set(AI,'SampleRate',fs);
% set(AI,'SamplesPerTrigger',duration*fs);
% set(AI,'TriggerRepeat',inf);
% set(AI,'TriggerFcn',@process_signal);
% set(AI,'UserData',data);

set(AI, 'TimerFcn', @process_signal);
set(AI, 'SampleRate', fs);
set(AI, 'SamplesPerTrigger', duration*fs);
set(AI, 'TriggerRepeat', 1);
set(AI, 'TriggerType', 'manual');
set(AI, 'UserData',data);
set(AI, 'TimerPeriod', 0.01);  
% set(AI, 'BufferingConfig',[duration*fs*2,20]);

function process_signal(obj, event)

if(get(obj,'SamplesAcquired') >= get(obj,'SamplesPerTrigger'))
    % Get handles
    user_data = get(obj,'UserData');
    handles = user_data.handles;
    
    % Get the data
    data = peekdata(obj,obj.SamplesAvailable);
    x = data;
    
    % Display the loaded signal
    disp_test_sig(x, handles);
    
    % Classify the number
    fs = str2double(get(handles.e_fs, 'String'));
    num = classify(x, fs);
    set(handles.t_number,'String',num2str(num));
    
    % Enable or dsable functionalities
    set(handles.b_start, 'String', 'Start');
    dis_en_stop(handles);
    
    % Stop logging
    if(~isempty(handles.AI))
        stop(handles.AI);
        delete(handles.AI);
    end
end

function disp_test_sig(x, handles)

n = 0:length(x)-1;
t = n/str2double(get(handles.e_fs, 'String'));

set(handles.a_test_line, 'XData', t, 'YData', x);
p = get(handles.a_test_line,'Parent');
set(p, 'XLim', [0 t(end)]);

function num = classify(y, fs)

y = y./max(abs(y));
num = numbers_DTW(y, fs, hamming(256), 128, 15, 2048, 21);
